#ifndef __APPL_H__
#define __APPL_H__


#define INTER_FREQ      100             // Hz
#define T_BETR_MIN_SAVE 30      //*** alle 30 min Betriebs-Minuten-Zhler auf EEPROM abspeichern

/**********************************************************************
 V25 processor definitions
**********************************************************************/
#define SFRBASE         0xff00

/*
#define	P0		SFRBASE+0x00	
#define	P1		SFRBASE+0x08
#define	P2		SFRBASE+0x10
#define	PT		SFRBASE+0x38
*/

// ** Prozessor Ports fuer Assing - String etc **
// Digital - IO - Ports
#define P0		0
#define P1		1
#define P2		2
#define P3		3
#define P4		4
#define P5		5
#define P6		6
#define P7		7
#define P8		8
#define P9		9
#define PBEEP	10

// analoge Eingaenge
#define AN0		0
#define AN1		1
#define AN2		2
#define AN3		3
#define AN4		4
#define AN5		5
#define AN6		6
#define AN7		7
#define AN8		8
#define AN9		9
#define AN10	10
#define AN11	11		
#define AN12	12
#define AN13	13
#define AN14	14
#define AN15	15
#define AN16	16
#define AN17	17
#define AN18	18
#define AN19	19
#define AN20	20
#define AN21	21
#define AN22	22
#define AN23	23

// analoge Ausgaenge
#define AO0		0
#define AO1		1
#define AO2		2
#define AO3		3

// Analogeingaenge der Impulsmessungen
#define AN24	24		// = TIN0
#define AN25	25		// = TIN1
#define AN26	26		// = TIN2
#define AN27	27		// = TIN3
// weitere Impuls- / Zaehlereingaenge t.b.d.

// Durchflussmesser (Impulse)
#define TIN0	0
#define TIN1	1
#define TIN2	2
#define TIN3	3
// weitere Impuls- / Zaehlereingaenge t.b.d.

// Hardware - Index im Assign-String
//#define HID_INTERN		0		// I/O der CPU, muss nicht angegeben werden, da default
//#define HID_EXP_MOD1	1		// 1. Erweiterungsplatine
//#define HID_EXP_MOD2	2		// 2. Erweiterungsplatine
//#define HID_EXP_MOD3	3		// 3. Erweiterungsplatine
//#define HID_EXP_MOD4	4		// 4. Erweiterungsplatine

#define HID_CouplingBRICK0	0x0201 
#define HID_CouplingBRICK1	0x0202



#define TIMER_FAKTOR	100


// **** Ports des MB91F361
#define	FREE	0

// DOs
#define	PJ		0

// DIs
#define	PL		0
#define PN		1


// Hardware-IDs/Index
#define HID_MASTER		0
#define HID_SLAVE1		1
#define HID_SLAVE2		2
#define HID_HLK_M1		3
#define HID_HLK_M2		4
#define HID_HLK_M3		5
#define HID_BZEIT_V_HLK	6
#define HID_DM1			7

#define HID_BZEIT_A_HLK	8
#define HID_ANST_HLK	9

#define HID_EBER1		10
#define HID_EBER2		11

#define HID_MAMA		12

#define	EXT_BUS0	0x1000
#define	EXT_BUS1	0x1001

#define	ExtBus0	2
#define	ExtBus1	3


#define	EXT_BUS0	0x1000
#define	EXT_BUS1	0x1001

#define	ExtBus0	2
#define	ExtBus1	3




extern void *PathlessProtokoll;
extern void *PathlessSysInfo;
extern void *PathlessChipCard;


void	doBasisPermInit(void);
void	doBasisPermLoop(void);
void	basisInter(void);
int		chkWinSomChange(TIME *zeit);
void	error_task(void);
//void	process(void);
void    do_betr_minuten(void);

void	task_exit(void);

typedef struct {
	long	BetrStd;	
	long	CntPermeat;
	long	CntKonzentrat;
	} UserEep;

typedef struct {
	unsigned char	ctrlOut;	
	unsigned char	sysErr;		
	unsigned char	data[6];	
	} IbOutBuf;

typedef struct {
	unsigned char	ctrlIn;		
	unsigned char	muxSel;		
	unsigned char	unused[6];
	} IbInBuf;

#define TIM_SBINTERVAL		TIM(5, TI_UP)
#define TIM_BETR		TIM(6, TI_UP)
#define TIM_BEEP		TIM(10, TI_DOWN)
#define TIM_NOTABSCH		TIM(11, TI_DOWN)
#define TIM_DOWN			TIM(12, TI_DOWN)	// allg. Zaehler nach unten
#define TIM_UP				TIM(13, TI_UP)		// allg. Zaehler nach oben




#define	LEN_OF_SENSOR_TAB 		250	// Lnge der Sensortabelle

// eigentliche Sensor-Tabelle mit allen 250 Punkten
extern int SensorTab[2][LEN_OF_SENSOR_TAB];

#ifdef UNITCONV_ON
long CElement_myconv(CElement RD_MROM *elem, long actval, RD_char RD_MRAM *unit, short *format);
long CElement_myrevconv(CElement RD_MROM *elem, long actval);
#endif // UNITCONV_ON

#endif

#include "FlowMeter.h"


