
#ifndef _protokoll_h_
	#define _protokoll_h_


#define	PROT_CONF_NR	50
#define	MAX_NUM_PROTS	10

typedef struct {
	unsigned short source;	// 0 = keine Struktur, 1 = MEM_IO (digitale und analoge E/As, Counter und Timer)
							// 2 = Flags, 3 = Prozessdaten
	unsigned short size;	// Bitmaske + Laenge des jeweiligen Elements in Bytes
				/*
				1.Byte: Bitmaske, falls es sich um ein DI oder DO handelt
				2.Byte: Laenge
				0 : 1 bit
				1 : char
				2 : short
				4 : long
				-1 : unsigned char
				-2 : unsigned short
				-4 : unsigned long
				oder laenger bei ESTR
				*/
	short offset;	// Offset (2 Byte) des Datums bezueglich des ausgewaehlten
					// Speicherbereichs (MEM_IO, Flags, Procs) an.
	short dummy; //*** Achtung: PC-seitig wird alignment 4 vorausgesetzt
#ifdef RD_MROM
	CElement RD_MROM *pElemAdr; // die Adresse vom Element
#else
	long pElemAdr; // Temporary solution until Bug 2253 is fixed
#endif
} PROT_CONF;



typedef struct {
	char	FormatId[4];
	short	ProtId;
	short	RecordsMax;
	long	RecordAdr;
	short	ElementsAct;
	short	RecordSize;
	PROT_CONF	ElementTab[PROT_CONF_NR];
	short	CheckSum;
	short	dummy; //*** Achtung: PC-seitig wird alignment 4 vorausgesetzt
	} PROT_HEADERA;
	
typedef struct {
	short	RecordsAct;
	short	RecordLast;
	short	CheckSum;
	} PROT_HEADERB;
	
typedef struct {
	unsigned char CheckSum;
	unsigned char StateTime[3];
	short	Date;
	} PROT_RECORD;
	
#endif
