#ifndef __SIM_H__
#define __SIM_H__

typedef int (*RDCALLCOMMON)(void* p, short typ1, char *arg1); // Typ der Callback-Funktion
typedef void (*RDCALLBACKLOGMESSAGE)(void* p, const wchar_t* windowname, const wchar_t* text); // Typ der Callback-Funktion

class DokTabs;
class DokTabLine;

// Definition der DLL-Funktion, die verwendet werden soll
typedef void (*DEFSetString)(long index, char *text, short len, int blocktype);
extern DEFSetString SetString;
typedef void (*DEFChangeSignal)(long index, void* val, long BitNr, int blocktype); 
extern DEFChangeSignal ChangeSignal;
typedef short (*DEFsetParamBuf)(char* ParBuf, long len);
extern DEFsetParamBuf setParamBuf;
typedef short (*DEFsetSystemBuf)(char* ParBuf, long len);
extern DEFsetSystemBuf setSystemBuf;
typedef void (*DEFsetSimSema)(CRITICAL_SECTION* SimSema);
extern DEFsetSimSema setSimSema;
typedef short (*DEFsetStatusBuf)(char* StatusBuf, long len);
extern DEFsetStatusBuf setStatusBuf;
typedef void (*DEFsetTimeZoom)(long TimeZoom1);
extern DEFsetTimeZoom setTimeZoom;
typedef  DokTabs* (*DEFAddDokTabLine)(char *id, short surfacenr, short pagenr, short htmlnr, wchar_t *t, short *w, char *eln);
extern DEFAddDokTabLine AddDokTabLine;
typedef void (*DEFsetPasswort)(short pwd);
extern DEFsetPasswort setPasswort;
typedef void (*DEFSIM_GetDtElements)(DokTabs* dt, char *buffer);
extern DEFSIM_GetDtElements SIM_GetDtElements;
typedef void (*DEFSimSetDokuLang)(short language);
extern DEFSimSetDokuLang SimSetDokuLang;
typedef __int64 (*DEFSimGetBurstGraTime)(void);
extern DEFSimGetBurstGraTime SimGetBurstGraTime;
typedef void (*DEFSimDraw)(void *pDC); 
extern DEFSimDraw SimDraw;
typedef void (*DEFSimResetSurface)(void);
extern DEFSimResetSurface SimResetSurface;
typedef void (*DEFInitializeFlags)(void);
extern DEFInitializeFlags InitializeFlags;
typedef void (*DEFInitializePars)(void);
extern DEFInitializePars InitializePars;
typedef void (*DEFInitializeProc)(void);
extern DEFInitializeProc InitializeProc;
typedef void (*DEFInitializeIOs)(void);
extern DEFInitializeIOs InitializeIOs;
typedef void (*DEFsetMode)(short betriebsart);
extern DEFsetMode setMode;
typedef void (*DEFSim_UninstallApiDll)(void);
extern DEFSim_UninstallApiDll Sim_UninstallApiDll;
typedef void (*DEFsendParamData)(char* ParBuf);
extern DEFsendParamData sendParamData;
typedef void (*DEFsendSystemData)(char* sysParBuf);
extern DEFsendSystemData sendSystemData;
typedef void (*DEFsendProcData)(char* ProcBuf); 
extern DEFsendProcData sendProcData;
typedef void (*DEFgetProcData)(char* ProcBuf); 
extern DEFgetProcData getProcData;
typedef void (*DEFgetParamData)(char* ParBuf);
extern DEFgetParamData getParamData;
typedef void (*DEFstart_sim)(void);
extern DEFstart_sim start_sim;
typedef void (*DEFSimExecCFunc)(unsigned char funcNr);
extern DEFSimExecCFunc SimExecCFunc;
typedef short (*DEFSimGetKaliStd)(short type, const char *desc, short *lOff, short *lFull, short *pOff, short *pFull);
extern DEFSimGetKaliStd SimGetKaliStd;
typedef short (*DEFSimGetPhysWert)(short type, const char *desc, long *phys);
extern DEFSimGetPhysWert SimGetPhysWert;
typedef short (*DEFSimGetKaliData)(short type, const char *desc, unsigned char *kalistruct);
extern DEFSimGetKaliData SimGetKaliData;
typedef void (*DEFSimSetKaliData)(short type, const char *desc, unsigned char *kalistruct);
extern DEFSimSetKaliData SimSetKaliData;
typedef void (*DEFSimSysmem2com)(void);
extern DEFSimSysmem2com SimSysmem2com;
typedef void (*DEFSimCom2Sysmem)(void);
extern DEFSimCom2Sysmem SimCom2Sysmem;
typedef void (*DEFSetRdCallCommon)(void* p, RDCALLCOMMON prdcc);
extern DEFSetRdCallCommon SetRdCallCommon;
typedef void (*DEFSetRdCallbackLogmessage)(void* p, RDCALLBACKLOGMESSAGE prdcc);
extern DEFSetRdCallbackLogmessage SetRdCallbackLogmessage;
typedef void (*DEFend_sim)(void);
extern DEFend_sim end_sim;
typedef void (*DEFstop_sim)(void);
extern DEFstop_sim stop_sim;
typedef long (*DEFSimGetBurstRate)(void);
extern DEFSimGetBurstRate SimGetBurstRate;
typedef __int64 (*DEFSimGetBurstTime)(void);
extern DEFSimGetBurstTime SimGetBurstTime;
typedef void (*DEFSimGetBurstConfig)(void **datenfeld);
extern DEFSimGetBurstConfig SimGetBurstConfig;
typedef  void (*DEFSimSetExitFunction)(short (*exit_func)(void));
extern DEFSimSetExitFunction SimSetExitFunction;
typedef  void (*DEFsetSimPauseMode)(unsigned char mode);
extern DEFsetSimPauseMode setSimPauseMode;
typedef  void (*DEFSIM_GetDtLine)(DokTabLine* dtl, short *htmlnr, short *pagenr, wchar_t *titel, char *werte);
extern DEFSIM_GetDtLine SIM_GetDtLine;
typedef  void (*DEFNewScreen)(	short screenID,	short maxlines,	short maxcolumns,	short grafikdisp,	const char *startmod,	short startsur);
extern DEFNewScreen NewScreen;
typedef  void (*DEFVererbeDokTab)(const char *base_id, const char *abgeleitetes_id);
extern DEFVererbeDokTab VererbeDokTab;
typedef  void (*DEFAddModToDef)(char *id, wchar_t *name, short zugriffsnr);
extern DEFAddModToDef AddModToDef;
typedef  void (*DEFAddDokTabInstanceNr)(char *id, short InstanceNr);
extern DEFAddDokTabInstanceNr AddDokTabInstanceNr;
typedef  void (*DEFhtml_sim)(short language);
extern DEFhtml_sim html_sim;
typedef  void (*DEFsetSimRTC)(long zeit, long datum);
extern DEFsetSimRTC setSimRTC;
typedef  void (*DEFsimDoSingleStep)(unsigned char task);
extern DEFsimDoSingleStep simDoSingleStep;
typedef  bool (*DEFsimIsRunning)(void);
extern DEFsimIsRunning simIsRunning;
typedef  void (*DEFsimReset)(void);
extern DEFsimReset simReset;
typedef void (*DEFsimRestart)(void);
extern DEFsimRestart simRestart;
typedef void (*DEFsimDisStr)(short x, short y, void *txt, short len, unsigned char col, unsigned char colbk, short curFont);
extern DEFsimDisStr simDisStr;
typedef void (*DEFsimDisExtRect)(short sx, short sy, short sizex, short sizey, char rad, unsigned char col, char contrastx, char contrasty, unsigned char mode);
extern DEFsimDisExtRect simDisExtRect;
#endif