#ifndef __vis_types_h__
#define __vis_types_h__  

#define NUMVISBINICON       40
#define NUMROTXYPICTS       5 // if changing this value the MaxMNumElem Define in visual.h must also be changed

#define VMHISTO             111
#define VMBAR               110
#define VGRAROTXY           109
#define VGRAROT             108
#define VGRALINE            107
#define VRADIOBUT           106
#define VCOMBOBOX           105
#define VSLIDER             104
#define VPROGBAR            103
#define VBAR                102
#define VGRA                101

#define	VNULL                   0
#define VTEXT1                  1
#define VTEXT2                  2
#define VTEXT3                  3
#define VTEXT4                  4
#define VTEXT5                  5

#define	VTYPE_OBJ	 		111
#define	VTYPE_LINE	 		1
#define	VTYPE_RECT	 		2
#define	VTYPE_CIRC	 		3
#define	VTYPE_SIZE	 		4
#define	VTYPE_TEXT	 		5
#define	VTYPE_ARC	 		6
#define	VTYPE_BITMAP 		7
#define	VTYPE_BUTTON 		8
#define	VTYPE_PICT	 		9

#define	VTYPE_EBIN			10
#define	VTYPE_ENUM			11
#define	VTYPE_ICON			12
#define	VTYPE_EMELEM		13
#define	VTYPE_FULL			14

#define	VTYPE_COND			15
#define	VTYPE_ACTION		16
#define	VTYPE_ACTIONICON	17 // wird auch fuer AKEY verwendet
#define	VTYPE_MENUBEGIN		18
#define	VTYPE_MENUEND		19
#define	VTYPE_AMENU			20
#define VTYPE_COLUMNBREAK	21
#define	VTYPE_DISPLAY 		22
#define	VTYPE_ACTIONENTER	23
#define	VTYPE_SIGCON		24
#define	VTYPE_SIGICON		25
#define	VTYPE_ACTIONCOND	26
#define	VTYPE_TOUCHKEY		27
#define	VTYPE_STATMACH		31
#define	VTYPE_SETPOS		32
#define	VTYPE_MELEMARRAY	33
#define	VTYPE_FILL	 		34
#define	VTYPE_ACTIONEXIT 	35
#define	VTYPE_VISLINE		36
#define	VTYPE_VISROT		37
#define	VTYPE_ACTIONPERM	38
#define	VTYPE_ACTIVITY		39


//*** Attribute fuer VisElem und ElemType (z.B. "MD=....");
#define	VATTRIB_DI			1	// 
#define	VATTRIB_JH			2	// JustageHor.
#define	VATTRIB_MD			3	// ModusDisplay
#define	VATTRIB_ME			4	// ModusEdit
#define	VATTRIB_PD			5	// PositionDescription
#define	VATTRIB_SV			6	// SizeVisual
#define	VATTRIB_ST			7	// Subtextindex Text (Value)
#define	VATTRIB_SD			8	// Subtextindex Description
#define	VATTRIB_SU			9	// Subtextindex Unit
#define	VATTRIB_PL			10	// PasswordLevel
#define	VATTRIB_NC			11	// NumberColumns
#define	VATTRIB_NL			12	// NumberLines
#define	VATTRIB_HD			13	// Hexdecimal
#define VATTRIB_PA          14  // Position Actval
#define VATTRIB_BK          15  // Background color
#define VATTRIB_CT          0x20    // Color Table will be ored with size or requested number in the lower bits
#define VATTRIB_MR          0x40    // Range of movement of ROTXY will be ored with size or requested number in the lower bits
#define VATTRIB_RR          0x80    // Range of rotation of ROTXY will be ored with size or requested number in the lower bits

#define	VATTRIB_X			0x100	// Zusatz fuer X-Auswahl (z.B. PDx)
#define	VATTRIB_Y			0x200	// Zusatz fuer Y-Auswahl (z.B. PDy)



//*** Anzeigeflags (ModeDisp) fuer Visualisierer
#define	DISP_VALUE			1		// Wert darstellen
#define	DISP_UNIT			2		// Einheit darstellen
#define	DISP_DESC			4		// Bezeichnung darstellen
#define	DISP_PREZERO		8		// Zahlen mit Vornullen darstellen
#define	DISP_UNIT_SPACELESS	0x10	// Einheit ohne Leerzeichen darstellen
//*** folgende fuer VisMultinum (Grafik)
#define	DISP_ZOOM2FULL		0x80	// Volle Darstellung
#define	DISP_SCALENUM		0x100	// Skaliernumerierung darstellen
#define	DISP_XZOOM			0x200	// X-Zoom (+Scrollbalken) ein
#define	DISP_YZOOM			0x400	// Y-Zoom (+Scrollbalken) ein
#define	DISP_RELTIME		0x800	// relative Zeitachse anstatt absoluter Zeitachse
#define	DISP_PRINT			0x1000	// Ausdruck (d.h. fuer verwendung in der surface_print)
#define	DISP_COMPRESS		0x2000	// Ausblenden von zeitraeumen ohne daten
#define	DISP_NO_TIMESCALE	0x4000	// Ausblenden der zeitskala in vismultinumhisto
#define	DISP_NO_NAME		0x8000	// Ausblenden von Namen und Y-Zoom = x

//*** Editflags (ModeEdit) fuer Visualisierer
#define	EDIT_OHNE		0		// keine Editierung
#define	EDIT_DIALOG		1		// Editierung im Dialogfenster
#define	EDIT_NORMAL		2		// Editierung an Ort und Stelle
#define	EDIT_DAUER		3		// Editierung mit mouse/touch up/down an Ort und Stelle
#define	EDIT_FOCUS		4		// keine Editierung aber Element trotzdem auswhlbar
#define EDIT_OHNE_PSWD	5		// Editierversuch von Element mit Passwortlevel und nicht ausreichendeer Berechtigung

typedef short VARPOOL_IDX;

//*** Achtung: wegen den unterschiedlichen Alignments der prozessoren muessen alle shorts innerhalb der strukturen
//***			auf geraden Positionen und alle longs auf vielfachen von 4 anfangen !!!
typedef struct
{
	short	IOnr;	// bei Elementen vom Assign AI oder AO: Index in der tab_e_ai[] bzw. tab_e_ao[]
	short	type;	// Assignmenttyp: analog/digital in/out
	XSTR	name;	// short als Index auf den Zeiger
	XSTR	desc;
	XSTR	info;
	XSTR	unit;
	//*** die folgenden werden nach RDNum gecastet
	long	setup;	// Standard-/Reset-Wert
	long	minRange;
	long	maxRange;
	short	format;	// Beinhaltet quasi "numDec" und "numDig"
					// Aufbau: 0xSNZD	Z=Anzahl der Zeichen
					//					D=Anzahl der Dezimalen
					//				    N: bit 0 = Vornullen ja/nein
					//                       S: bit 0 = Vorzeichen ja/nein
					//					
  	unsigned short	setupIndex;		// ist != 0xffff, falls der setupwert von einem anderen Element kommt
  	unsigned short	minRangeIndex;	// ist != 0xffff, falls der minRange von einem anderen Element kommt
  	unsigned short	maxRangeIndex;	// ist != 0xffff, falls der maxRange von einem anderen Element kommt
  	short	schrittweite;
} DENum;

typedef struct
{
	short	IOnr;	// bei Elementen vom Assign DI oder DO: Index in der tab_e_di[] bzw. tab_e_do[]
	short	type;	// Assignmenttyp: analog/digital in/out
	XSTR	name;
	XSTR	desc;
	XSTR	info;
	XSTR	unit;
	XSTR	selStr;		// Index des Strings der ersten Selektionsmoeglichkeit (weitere Selektionsmoegl. jeweils folgende Indizes)
	XSTR	selDesc;	// Index des Beschreibung der ersten Selektionsmoeglichkeit (weitere Selektionsmoegl. jeweils folgende Indizes)
	char	numSel;		// Anzahl der Selektionsmoeglichkeiten
	unsigned char	setup;		// Standartwert
	unsigned char	numColumns;	// maximale laenge der ersten Zeile (eines Selektionstextes) ueber alle Selektionsmoeglichkeiten und allen Sprachen
								// falls der wert negativ ist endet die zeile mit "\r"
} DEBin;
// ACHTUNG !!! Im Anschluss an diese Struktur werden beim Export (OSDL.BIN) ggf. noch weitere Bytes (wie oben) angehaengt, die
// die max. Zeilenlaengen von ggf. weiteren Zeilen beinhalten (sofern mehrzeilige Selektionstexte verwendet werden)

typedef struct
{
	short	type;	// Assignmenttyp: analog/digital in/out
	XSTR	name;
	XSTR	desc;
	XSTR	info;
	unsigned char	lenStr;		// Stringlaenge
	unsigned char	longtext;
	XSTR	setup;
} DEStr;

typedef struct
{
	short	type;	// Assignmenttyp: analog/digital in/out
	XSTR	name;
	XSTR	desc;
	XSTR	info;
	short	ttype;		//*** 0=ohne sec, ohne ms / 1=mit sec., ohne ms / 2=mit sec und ms 
	XSTR	setup;
} DETim;

typedef struct
{
	short	type;	// Assignmenttyp: analog/digital in/out
	XSTR	name;
	XSTR	desc;
	XSTR	info;
	char	dtype;		// mode=1 => --.--.YYYY
	XSTR	setup;
} DEDat;


typedef struct
{
	short	nummer;				// nummer der surface
	XSTR	desc;				// description der surface
} DSurface;


typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
} DVisObj;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	sx, sy;				// startpos. of line
	short	ex, ey;				// endpos. of line
	unsigned short	pen;		// pen size (pixel)
	unsigned char	col;		// color
} DVisLine;

// Attention when changing this structure also change DVisRectExt (see comment
// there)
typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	x;					// startpos. of rectangle
	short	y;					// startpos. of rectangle
	short	sizex;				// size of rectangle
	short	sizey;				// size of rectangle
	unsigned char	pen;		// pen size (pixel)
	unsigned char	fill;		// fill/draw mode: 
	unsigned char	col;		// color
} DVisRect;

// Attention has to have the same start structure as DVisRect, because binary
// data will be read out as DVisRect and fill mode evaluated to decide if
// it is an extended rectangle
typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	x;					// startpos. of rectangle
	short	y;					// startpos. of rectangle
	short	sizex;				// size of rectangle
	short	sizey;				// size of rectangle
	unsigned char	rad;		// radius of corners (in DVisRect pen size)
	unsigned char	fill;		// fill/draw mode:
	unsigned char	col;		// color
	char    contrastx;			// Contrast change for color gradient in X-axis
	char    contrasty;			// Contrast change for color gradient in Y-axis
	unsigned char   mode;		// Drawing mode:	0x01: Border bottom
								//                  0x02: Border top
								//                  0x04: Border left
								//                  0x08: Border right
								//                  0x10: 3D-effect enabled
} DVisRectExt;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	x;					// startpos. of text
	short	y;					// startpos. of text
	XSTR	text;				// text to draw
	unsigned short	size;		// Font size
	unsigned char	col;		// color
	unsigned char	colbk;		// background color
	short	horAusr;			// horizontal alignment
} DVisText;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	posx, posy;			// Position of SetPos
	unsigned short	xPosIndex;	// is != 0xffff, if x-Position comes from another element
	unsigned short	yPosIndex;	// is != 0xffff, if y-Position comes from another element
} DVisSetPos;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	x, y;				// Position of circle
	short	radx, rady;			// Radius of circle
	short	pen;				// Pensize
	unsigned char	col;		// color
} DVisCirc;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	XPTR	items;				// Index auf first picture item
	short	x;					// offset position
	short	y;					// offset position
} DVisSize;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	XPTR	items;				// Index auf first picture item
} DVisPict;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	x, y;				// Center Position of arc
	short	radx, rady;			// Radius of arc
	short	phis,phie;			// Start/End angle of arc
	short	pen;				// Pensize
	unsigned char	col;		// color
	unsigned char	fill;		// Filling mode
} DVisArc;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	x;					// Position of bitmap
	short	y;					// Position of bitmap
	long	mem;				// Offset of bitmap in memory
} DVisBitmap;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	xl, xr, yo, yu;		// Position and size of menu
	short	menuoptions;		// Menu options
	VARPOOL_IDX numMenuIdx;		// Index to variable holding count of menu items
	VARPOOL_IDX heightIdx;		// Index to variable holding height of all menu items [in pixel]

	VARPOOL_IDX startLineIdx;	// Index to variable holding index of current first line of menu (scrolling)
	VARPOOL_IDX oldstartLineIdx;// Index to variable holding previous index of first line of menu (scrolling)
	VARPOOL_IDX actLineIdx;		// Index to variable holding current index of cursor position
	VARPOOL_IDX oldLineIdx;		// Index to variable holding previous index of cursor position
	unsigned char	col;		// color
	unsigned char	colbk;		// background color
	unsigned short	fontsize;	// Font size in menu
	unsigned char	colsel;		// color of current selection
	unsigned char	colselbk;	// background color of current selection
} DVisMenuBegin;

// DVisMenuEnd does not exist, because there are no information in there, so
// DVisObj is used instead

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	XPTR	actions;			// Index of first action of AIcon
} DVisAction;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	XPTR	actions;			// Index of first action of AIcon
	short	el_ind;				// Index of element in element table
	long	condwert;			// Value to compare with
	char	condoperator;		// Character identifying the operator
	char	condupdate;			// Triggers redraw of surface
	VARPOOL_IDX	evalidx;		// Index to variable holding last evaluation result
} DVisActionCondition;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	XPTR	actions;			// Index of first action of AMenu
	short	xpos, ypos;			// Position of AMenu line
	XSTR	menuname;			// Text to display for AMenu
	unsigned short	size;		// Font size
	unsigned char	col;		// color
	unsigned char	colbk;		// background color
	short	horAusr;			// horizontal alignment
} DVisAMenu;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	XPTR	actions;			// Index of first action of AIcon
	short	xpos, ypos;			// Position of AIcon
	XSTR	menuname;			// Text to display for AIcon
	short	taste;				// Key on which to react
	XPTR	pictID;				// Picture to display as background for Icon
	XPTR	pressedPictID;		// Picture to display when icon is pressed
	XPTR	releasedPictID;		// Picture to display when icon is released
} DVisActionIcon;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	xpos, ypos;			// Position of Touchkey
	XSTR	menuname;			// Text to display for Tochkey
	short	taste;				// Key on which to react
	XPTR	pictID;				// Picture to display as background for Icon
	XPTR	pressedPictID;		// Picture to display when icon is pressed
	XPTR	releasedPictID;		// Picture to display when icon is released
} DVisTouchKey;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	condtype;			// 0=IF, 1=ELSE, 2=ENDIF
	short	el_ind;				// Index of element in element table
	long	condwert;			// Value to compare with
	char	condoperator;		// Character identifying the operator
	char	condupdate;			// Triggers redraw of surface
	VARPOOL_IDX evalidx;		// Index to variable holding last evaluation result
} DVisCond;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	offsetx, offsety;	// Position of full
	short modul;				// Index of module in element(!) table
	short surfaceNr;			// Surface number of surface in full
	short varpooloff;			// Offset needed for every access to variable pool in full
#if RD_PROPFONT != 0
	short propvarpooloff;		// Offset needed for every access to variable pool used for propfonts in full
#endif // RD_PROPFONT != 0
} DVisFull;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	posX;				// Position of element visualizer
	short	posY;				// Position of element visualizer
	XPTR	format;				// Index of visualizer format
	XPTR	visdata;			// Index of visualization type data
} DVisGElem;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	posX;				// Position of element visualizer
	short	posY;				// Position of element visualizer
	XPTR	format;				// Index of visualizer format
	XPTR	visdata;			// Index of visualization type data
	unsigned short	vistype;	// Type of visualizer
	unsigned char	col;		// color
	unsigned char	colbk;		// background color
	short	el_ind;				// Index of element in element table
								// Top 4 bits are used for display mode:
								// 0=normal display of act value
								// 1=display of stdval
								// 2=display of minRange
								// 3=display of maxRange
	VARPOOL_IDX oldvalueidx;	// Index to variable holding value of last surface interpreter run
	#if RD_PROPFONT != 0
		VARPOOL_IDX oldpixsizeidx;	// Index to variable holding value of string size of last surface interpreter run
	#endif // RD_PROPFONT != 0
} DVisSElem;

typedef struct
{
	XPTR	next;				// Index of next visualization object
	short	objtype;			// Type of visualization object
	short	posX;				// Position of element visualizer
	short	posY;				// Position of element visualizer
	XPTR	format;				// Index of MElem format
	XPTR	visdata;			// Index of visualization type data
	XPTR	el_ind;				// Index of element indices for numElems elements
	XPTR	oldvalueidx;		// Index of indices for holding last values of numElems elements
	unsigned char vistype;		// Type of visualizer
	unsigned char numElems;		// Number of elements in element visualizer
} DVisMElem;

// Union of all visualizer objects
union UVisObj
{
	DVisObj visobj;
	DVisLine visline;
	DVisRect visrect;
	DVisRectExt visrectext;
	DVisText vistext;
	DVisSetPos vissetpos;
	DVisCirc viscirc;
	DVisSize vissize;
	DVisPict vispict;
	DVisArc visarc;
	DVisBitmap visbitmap;
	DVisMenuBegin vismenubegin;
	DVisActionCondition visactioncondition;
	DVisAMenu visamenu;
	DVisAction visaction;
	DVisActionIcon visactionicon;
	DVisTouchKey vistouchkey;
	DVisCond viscond;
	DVisFull visfull;
	DVisGElem visgeneralelem;
	DVisSElem vissingleelem;
	DVisMElem vismultielem;
};

typedef struct
{
	XPTR	pictBk;						// Index of background picture
	XPTR	pictStat[NUMVISBINICON];	// Array of indices of state pictures
} DVisBinIcon;

typedef struct
{
	XPTR	pictBk;				// Index of background picture
	XPTR	pictLineRot;		// Index of picture to move/rotate
} DVisDefLineRot;

typedef struct
{
	XPTR	pictBk;						// Index of background picture
	XPTR	pictRot[NUMROTXYPICTS];		// Array of indices of rotation pictures (for each element group)
} DVisDefRotXY;

#endif // __vis_types_h__
