@echo off
setlocal ENABLEEXTENSIONS EnableDelayedExpansion

rem $Id: comp_des.bat 8889 2016-03-11 15:48:34Z hstrauss $
rem
rem Copyright (c) IMACS GmbH Germany. All rights reserved.
rem

rem Only execute batch, if called from updated makectr.bat (see copy_arg_batches.bat)
if not defined RD_MAKECTR_STATE (
	goto end
)

echo ===== STARTING PRE-COMP BATCH =====
REM *** execute PRE-compilation batch
IF EXIST comp_des_pre.bat CALL comp_des_pre
echo    ... done

echo ===== COPY OF SYSTEM FILES =====
REM *** copy environ.def
copy environ.def ..\sim\environ.def >NUL 2>NUL
copy environ.def ..\..\common\environ.def >NUL 2>NUL

rem kopieren aller radon systemdateien vor der design-compilierung
call "%OSDL_SYS%\ctr_Lib\arg_batches\copy_sys.bat" >NUL 2>NUL

rem Lschen aller mglicherweise existierenden Teildateien der module.c, so dass hinterher nur die neu erzeugten existieren
IF EXIST module*.c @del module*.c >NUL 2>NUL
rem Delete alle ventually existing RDI-files
if exist rdi.def del rdi.def >NUL 2>NUL
if exist rdi_offtab.c del rdi_offtab.c >NUL 2>NUL
if exist rdi_pnttab.c del rdi_pnttab.c >NUL 2>NUL
if exist rdi_meta.c del rdi_meta.c >NUL 2>NUL
rem Delete all eventually existing preserve Files
IF EXIST preservePar.c del preservePar.c >NUL 2>NUL
IF EXIST preserveSys.c del preserveSys.c >NUL 2>NUL
IF EXIST preserveProc.c del preserveProc.c >NUL 2>NUL
IF EXIST preserveTab.c del preserveTab.c >NUL 2>NUL
echo    ... done

echo ===== STARTING DESIGN COMPILATION =====
IF EXIST custom_comp_des.bat (
	CALL custom_comp_des.bat
) ELSE (
	if not exist ..\..\common\radGEN\radGEN.exe (
		echo .	.	.	radGEN.exe not found. Common and rc_lib not matching? > error.txt
		echo radGEN.exe not found. Common and rc_lib not matching?
	) else (
		..\..\common\radGEN\radGEN /NO_BREAK
		IF NOT ERRORLEVEL 1 (
			rem If radCASE didn't throw an error (so no version mismatch) check if all executables are there
			if not exist ..\..\common\radMON\radMON.exe (
            	echo .	.	.	radMON\radMON.exe not found. >> error.txt
				echo radMON\radMON.exe not found.
			)
			if not exist ..\..\common\radMONDebug\radMON.exe (
            	echo .	.	.	radMONDebug\radMON.exe not found. >> error.txt
				echo radMONDebug\radMON.exe not found.
			)
			if not exist ..\..\common\release\Common.exe (
            	echo .	.	.	Common.exe not found. >> error.txt
				echo Common.exe not found.
			)
		)
	)
)
echo    ... done

echo ===== STARTING POST-COMP BATCH =====
IF EXIST  comp_des_post.bat CALL comp_des_post

echo    ... done

:end
