@echo off
setlocal ENABLEEXTENSIONS
setlocal EnableDelayedExpansion

rem $Id: prepare_sim.bat 2050 2009-09-18 12:40:08Z hstrauss $
rem
rem Copyright (c) IMACS GmbH Germany. All rights reserved.
rem
rem This script updates the Sim project with files from rc_lib matching the
rem current Visual Studio version

rem Only execute batch, if called from updated makectr.bat (see copy_arg_batches.bat)
if not defined RD_MAKECTR_STATE (
	goto end
)

echo ===== COPY OF SIM DIRECTORY =====
xcopy "%OSDL_SYS%\soft\Sim\*" ..\Sim /E /Y /I >NUL 2>NUL
if exist ..\Sim\Sim.sln del ..\Sim\Sim.sln
copy "%OSDL_SYS%\ctr_Lib\arg_batches\devenv_sim.bat"   ..\sim >NUL 2>NUL
echo    ... done

echo ===== DETERMINING SUPPORTED VS VERSIONS =====
set SupVersion=
if exist "%OSDL_SYS%\soft\Sim2005" set "SupVersion=!SupVersion! 8.0"
if exist "%OSDL_SYS%\soft\Sim2008" set "SupVersion=!SupVersion! 9.0"
if exist "%OSDL_SYS%\soft\Sim2010" set "SupVersion=!SupVersion! 10.0"
if exist "%OSDL_SYS%\soft\Sim2012" set "SupVersion=!SupVersion! 11.0"
if exist "%OSDL_SYS%\soft\Sim2013" set "SupVersion=!SupVersion! 12.0"
if exist "%OSDL_SYS%\soft\Sim2015" set "SupVersion=!SupVersion! 14.0"
echo    ... done

echo ===== DETERMINING LATEST INSTALLED VS VERSION =====
for %%a in (!SupVersion!) do (
	for %%b in (VCExpress\ VisualStudio\) do (
		for %%c in (SOFTWARE\Microsoft\ SOFTWARE\Wow6432Node\Microsoft\) do (
			set KEY_NAME="HKEY_LOCAL_MACHINE\%%c%%b%%a\Setup\VC"
			for /F "usebackq tokens=2*" %%d in (`REG QUERY !KEY_NAME! /v ProductDir 2^>nul`) do (
				set "VERSION=%%a"
			)
		)
	)
)

if "!VERSION!"=="8.0" set VSVER=2005
if "!VERSION!"=="9.0" set VSVER=2008
if "!VERSION!"=="10.0" set VSVER=2010
if "!VERSION!"=="11.0" set VSVER=2012
if "!VERSION!"=="12.0" set VSVER=2013
if "!VERSION!"=="14.0" set VSVER=2015

if "!VSVER!"=="" goto error

echo Visual Studio !VSVER!
echo    ... done
echo ===== COPY OF VS VERSION MATCHING FILES =====
xcopy "%OSDL_SYS%\soft\Sim!VSVER!\*" ..\Sim /E /Y /I >NUL 2>NUL
rem Hardwarelocked-Version handling
if not exist "%OSDL_SYS\ctr_lib\Source\vis.c" (
	if exist ..\SimLib\VS!VSVER! copy ..\SimLib\VS!VSVER!\*.* ..\CTR /Y >NUL 2>NUL
)
echo    ... done

if exist ..\Sim\CustomProj\NUL (
	echo ===== COPY OF CUSTOM PROJECT FILES =====
	copy "..\Sim\CustomProj\*" ..\Sim /Y >NUL 2>NUL
	echo    ... done
)

if exist "..\Sim\SIM.vcproj.%USERDOMAIN%.%USERNAME%.user" goto end
if NOT exist ..\Sim\SIM.vcproj.machinename.username.user goto end
copy /Y ..\Sim\SIM.vcproj.machinename.username.user "..\Sim\SIM.vcproj.%USERDOMAIN%.%USERNAME%.user" >NUL 2>NUL
goto end

:error
echo .	.	.	Could not determine Visual Studio version > error.txt
echo Could not determine Visual Studio version
exit /b 1

:end