//
// $Id: ctr_init.h 9238 2016-09-23 06:34:52Z afoltinek $
//
// Copyright (c) IMACS GmbH Germany. All rights reserved.
//
#ifndef __CTR_INIT_H__
#define __CTR_INIT_H__

#include "include_all.h"
#include "../APPL/project.tio"

#ifndef ___CTR___
	unsigned char		hEeprom[SIM_EEP_LEN];
	RD_CONST short GInter_Rate = INTER_TASK_RATE;
	RD_CONST short G_maxAnzScreens = ANZ_SCREENS;
#endif


//******* storage for radCASE-generated structures. defined here to avoid size problems in precompiled deliveries ****

// all Flags
FLAG	RD_MRAM					Flags;
FLAG	RD_MRAM *				Flag = &Flags;
RD_CONST short					GFlagSize = sizeof(FLAG);
RD_CONST void RD_MRAM *			GFlag = (RD_CONST void RD_MRAM *)&Flags;
RD_CONST void RD_MROM *			GInitFlag =   (void RD_MROM *)&InitFlag;

// all Param Data
PARAM	RD_MRAM					ParamData ;
#if ((NO_EMB_HMI == 0) && (RD_NO_EDIT_COPY == 0))
PARAM	RD_MRAM					ParamEd;	
PARAM	RD_MRAM *	RD_CONST	GParamEd = &ParamEd;
#endif
PARAM RD_MRAM * RD_CONST		GParam = &ParamData ;
RD_CONST short					GParamSize = sizeof(PARAM);
RD_CONST short					GParamVers = VERS_PARAM;
RD_CONST void RD_MROM *			GInitParam = (void RD_MROM *)&InitPar;

// all SysParam Data
SYSTEM	RD_MRAM					SystemData ;
#if ((NO_EMB_HMI == 0) && (RD_NO_EDIT_COPY == 0))
SYSTEM	RD_MRAM					SystemEd;
SYSTEM	RD_MRAM * RD_CONST		GSystemEd = &SystemEd;
#endif
SYSTEM RD_MRAM * RD_CONST		GSystem = &SystemData ;
RD_CONST short					GSystemSize = sizeof(SYSTEM);
RD_CONST short					GSystemVers = VERS_SYSTEM;
RD_CONST void RD_MROM *			GInitSystem = (void RD_MROM *)&InitSystem;

// all Kali data
#if KALI_ON != 0
EEP_Kali RD_MRAM				KalibData ;
EEP_Kali RD_MRAM				kaliEd;		// immer als Container erforderlich, da in project.tio in einer Tabelle darauf beim Compilieren Bezug genommen wird
#if ((NO_EMB_HMI == 0) && (RD_NO_EDIT_COPY == 0))
EEP_Kali RD_MRAM * RD_CONST		GKaliEd = &kaliEd;
#endif
EEP_Kali RD_MRAM * RD_CONST		GKali   = &KalibData ;
RD_CONST short					GKaliSize = sizeof(EEP_Kali);
RD_CONST short					GKaliVers = VERS_KALI;
#endif

// all Proc data
RD_PROC	RD_MRAM					Process;
RD_PROC	RD_MRAM					ProcessCopy;	// Copy of all Process data for compare to detect changes
RD_PROC RD_MRAM * RD_CONST		GProc = &Process;
RD_PROC RD_MRAM * RD_CONST		GProcCopy = &ProcessCopy;
RD_CONST short					GProcSize = sizeof(RD_PROC);
RD_CONST short					GProcVers = VERS_PROC;
RD_CONST void RD_MROM *			GInitProc = (void RD_MROM *)&InitProc;

// all Remanent data
long	RD_MRAM					Remanent[(REMANENT_LEN+3)/4];		// see module.c. defined as long to avoid alignment problems
long	RD_MRAM					RemanentCopy[(REMANENT_LEN+3)/4];	// Copy of all Remanent data for compare to detect changes
long	RD_MRAM * RD_CONST		GRemanent = Remanent ;
long	RD_MRAM * RD_CONST		GRemanentCopy = RemanentCopy ;
RD_CONST short					GremanentLen = REMANENT_LEN;

// Touch data
#if TOUCH_ON != 0
RD_CONST short GTouchVers = VERS_TOUCH;
#endif

#if NO_FORCEMODE == 0
#if (RD_NumEdi > 0)
unsigned char ForceDI_Real[(RD_NumEdi+7)/8];
unsigned char ForceDI_Active[(RD_NumEdi+7)/8];
#else
unsigned char ForceDI_Real[1];
unsigned char ForceDI_Active[1];
#endif

#if (RD_NumEdo > 0)
unsigned char ForceDO_Real[(RD_NumEdo+7)/8];
unsigned char ForceDO_Active[(RD_NumEdo+7)/8];
#else
unsigned char ForceDO_Real[1];
unsigned char ForceDO_Active[1];
#endif

unsigned char* GForceDI_Real=ForceDI_Real;
unsigned char* GForceDI_Active=ForceDI_Active;

unsigned char* GForceDO_Real=ForceDO_Real;
unsigned char* GForceDO_Active=ForceDO_Active;
#endif

//*** Werte die sich zu Laufzeit nicht aendern aber wegen der Lib-Version nicht als defines generiert werden koennen

#if RD_NO_BLINK == 0
	//*** Blinkfrequenz im Radon design optional einstellbar
	#ifdef BLINK_FREQ
		RD_CONST short G_Blink_Freq = BLINK_FREQ;
	#else
		//*** standardmaessig 5 * 100ms
		RD_CONST short G_Blink_Freq = 5;
	#endif


	//*** Blinktyp im Radon design optional einstellbar
	#ifdef BLINK_TYPE
		RD_CONST short G_Blink_Type = BLINK_TYPE;
	#else
		//*** standardmaessig
		RD_CONST short G_Blink_Type = 0;
	#endif
#endif // RD_NO_BLINK == 0

#if NO_EMB_HMI == 0
#ifdef T_KEY_ABORT
	RD_CONST short G_t_key_abort = T_KEY_ABORT;
	RD_CONST short G_sur_key_abort = SUR_KEY_ABORT;
#endif
#endif

RD_CONST short G_numAKeyGlo = NUM_AKEYGLOBAL;
RD_CONST short G_maxAnzVis = MAXANZVIS_ARRAYLEN;
RD_CONST short G_maxAnzBarVis = MAXANZBARVIS;

#if RD_GAMMA != 0
RD_CONST short G_numGammaElems = RD_GAMMA_COUNT;
#endif

RD_CONST short GAlignment = ALIGNMENT;
RD_CONST short GSoftVers = VERS_SOFT;
RD_CONST short GDevice_id = DEVICE_ID;
RD_CONST short GSubtextNumber = RD_SUBTEXTNR;

#if RD_NO_COMMUNICATION == 0
unsigned long usCommBlock[NUM_IO_BYTES / 4 + 5];
#endif
#if ((!defined(___CTR___)) || (RD_NO_COMMUNICATION == 0))
RD_CONST short GComFlagSize = MEM_COM_FLAG_LEN;
RD_CONST short G_IOSize = MEM_IO_LEN;
#endif


#if ((NO_SYSTXT == 0) &&  (NO_EMB_HMI == 0))
	RD_CONST short GWrong_pwd = WRONG_PWD;
	RD_CONST short GZugang_verw = ZUGANG_VERW;
	RD_CONST short GSave_mit = SAVE_MIT;
	RD_CONST short GBerechtigung = BERECHTIGUNG;
	RD_CONST short GTxtEingeben = EINGEBEN;
	RD_CONST short GTxtEingeben_S = EINGEBEN_S;
	RD_CONST short GSpeichern = SPEICHERN;
	RD_CONST short GSpeichern_s = SPEICHERN_S;
	RD_CONST short GExecute = EXECUTE;
	RD_CONST short GExecute_s = EXECUTE_S;
	RD_CONST short GDelete = STR_DELETE;
	RD_CONST short GDelete_s = STR_DELETE_S;
	RD_CONST short GTxt_ja = TXT_JA;
	RD_CONST short GTxt_nein = TXT_NEIN;
	RD_CONST short GJa_enter = JA_ENTER;
	RD_CONST short GTastetippen = TASTETIPPEN;
	RD_CONST short GTastetippen_s = TASTETIPPEN_S;
	RD_CONST short GNicht_editierbar = NICHT_EDITIERBAR;
	RD_CONST short GNicht_editierbar_s = NICHT_EDITIERBAR_S;
	RD_CONST short GMenuhelp = MENUHELP;
	RD_CONST short GStandartwert = STANDARDWERT;
	RD_CONST short GBereich = BEREICH;
	RD_CONST short GKein_device = KEIN_DEVICE;
	RD_CONST short GElemHelp = ELEMHELP;
	RD_CONST short GBereichsfehler = BEREICHSFEHLER;
	RD_CONST short GZul_bereich = ZUL_BEREICH;
	RD_CONST short GZeichen = ZEICHEN;
	RD_CONST short GFehler = FEHLER;
	RD_CONST short GGewaehlterwert = GEWAEHLTERWERT;
	RD_CONST short GZeit = ZEIT;
	RD_CONST short GDatum = DATUM;
	RD_CONST short GEdit_mit = EDIT_MIT;
	RD_CONST short GKrit_funk1 = KRIT_FUNK1;
	RD_CONST short GKrit_funk2 = KRIT_FUNK2;
	RD_CONST short GKrit_funks = KRIT_FUNK_S;

	#if KALI_ON != 0
		RD_CONST short	GXTXT_KaliEditTLow = 		XTXT_KALI_EDIT_T_LOW;
		RD_CONST short	GXTXT_KaliEditTHigh =		XTXT_KALI_EDIT_T_HIGH;
		RD_CONST short	GXTXT_KaliEditLogH =		XTXT_KALI_EDIT_LOGH;
		RD_CONST short	GXTXT_KaliEditLogL =		XTXT_KALI_EDIT_LOGL;
		RD_CONST short	GXTXT_KaliEditPhyH =		XTXT_KALI_EDIT_PHYH;
		RD_CONST short	GXTXT_KaliEditPhyL =		XTXT_KALI_EDIT_PHYL;
		RD_CONST short	GXTXT_KaliLogH =			XTXT_KALI_LOGH;
		RD_CONST short	GXTXT_KaliLogL =			XTXT_KALI_LOGL;
		RD_CONST short	GXTXT_KaliPhyH =			XTXT_KALI_PHYH;
		RD_CONST short	GXTXT_KaliPhyL =		    XTXT_KALI_PHYL;
		RD_CONST short	GXTXT_KaliTeachHigh =		XTXT_KALI_TEACH_HIGH;
		RD_CONST short	GXTXT_KaliTeachStandard =	XTXT_KALI_TEACH_STANDARD;
		RD_CONST short	GXTXT_KaliTeachLow =		XTXT_KALI_TEACH_LOW;
	#endif
	RD_CONST short GXTXT_KaliSetActPhys =       XTXT_KALI_SET_ACT_PHYS;
#endif





RD_CONST CModul RD_MROM *pGRoot = (RD_CONST CModul RD_MROM *)&Root;
RD_CONST short GTimerNumber = NUMTIM;
RD_CONST short GSaveMenuPos = SAVEMENUPOS;
RD_CONST unsigned long GLang_enable[] = 
{
	LANG_ENABLE,
#if RD_SELMAXSIZE > 1
	LANG_ENABLE1,
#if RD_SELMAXSIZE > 2
	LANG_ENABLE2,
#if RD_SELMAXSIZE > 3
	LANG_ENABLE3,
#if RD_SELMAXSIZE > 4
	LANG_ENABLE4,
#endif
#endif
#endif
#endif
};

#if NO_EMB_HMI == 0
	#if DISP_GRA != 0

		#ifdef PICT_PcSchloss
		RD_CONST XPTR GP_Lock = PICT_PcSchloss;
        #else
        RD_CONST XPTR GP_Lock = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcInfo
		RD_CONST XPTR GP_Info = PICT_PcInfo;
        #else
        RD_CONST XPTR GP_Info = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcConti
		RD_CONST XPTR GP_Conti = PICT_PcConti;
        #else
        RD_CONST XPTR GP_Conti = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcEnter
		RD_CONST XPTR GP_Enter = PICT_PcEnter;
        #else
        RD_CONST XPTR GP_Enter = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcHalt
		RD_CONST XPTR GP_Stop = PICT_PcHalt;
        #else
        RD_CONST XPTR GP_Stop = RD_NOBINDATA;
		#endif

		#ifdef PICT_PcAbort
		RD_CONST XPTR GP_Abort = PICT_PcAbort;
        #else
        RD_CONST XPTR GP_Abort = RD_NOBINDATA;
		#endif

		#ifdef PICT_PcFactory
		RD_CONST XPTR GP_Factory = PICT_PcFactory;
        #else
        RD_CONST XPTR GP_Factory = RD_NOBINDATA;
		#endif

		#ifdef PICT_PcBack
		RD_CONST XPTR GP_Back = PICT_PcBack;
        #else
        RD_CONST XPTR GP_Back = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcBlack
		RD_CONST XPTR GP_Black = PICT_PcBlack;
        #else
        RD_CONST XPTR GP_Black = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcEditNum
		RD_CONST XPTR GP_EditNum = PICT_PcEditNum;
        #else
        RD_CONST XPTR GP_EditNum = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcEditBin
		RD_CONST XPTR GP_EditBin = PICT_PcEditBin;
        #else
        RD_CONST XPTR GP_EditBin = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcEditTim
		RD_CONST XPTR GP_EditTim = PICT_PcEditTim;
        #else
        RD_CONST XPTR GP_EditTim = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcEditStr
		RD_CONST XPTR GP_EditStr = PICT_PcEditStr;
        #else
        RD_CONST XPTR GP_EditStr = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcEditDat
		RD_CONST XPTR GP_EditDat = PICT_PcEditDat;
        #else
        RD_CONST XPTR GP_EditDat = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcAchtung2
		RD_CONST XPTR GP_Attention = PICT_PcAchtung2;
        #else
        RD_CONST XPTR GP_Attention = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcNo
		RD_CONST XPTR GP_No = PICT_PcNo;
        #else
        RD_CONST XPTR GP_No = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcYes
		RD_CONST XPTR GP_Yes = PICT_PcYes;
        #else
        RD_CONST XPTR GP_Yes = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcFrage2
		RD_CONST XPTR GP_Question = PICT_PcFrage2;
        #else
        RD_CONST XPTR GP_Question = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcKaliAI
		RD_CONST XPTR GP_KaliAI = PICT_PcKaliAI;
        #else
        RD_CONST XPTR GP_KaliAI = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcKaliAO
		RD_CONST XPTR GP_KaliAO = PICT_PcKaliAO;
        #else
        RD_CONST XPTR GP_KaliAO = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcKali_L
		RD_CONST XPTR GP_Kali_L = PICT_PcKali_L;
        #else
        RD_CONST XPTR GP_Kali_L = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcKali_H
		RD_CONST XPTR GP_Kali_H = PICT_PcKali_H;
        #else
        RD_CONST XPTR GP_Kali_H = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcManuell
		RD_CONST XPTR GP_Manuell = PICT_PcManuell;
        #else
        RD_CONST XPTR GP_Manuell = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcStepInc
		RD_CONST XPTR GP_StepInc = PICT_PcStepInc;
        #else
        RD_CONST XPTR GP_StepInc = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcFactManu
		RD_CONST XPTR GP_FactManu = PICT_PcFactManu;
        #else
        RD_CONST XPTR GP_FactManu = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcCaliUpDn
		RD_CONST XPTR GP_CaliUpDn = PICT_PcCaliUpDn;
        #else
        RD_CONST XPTR GP_CaliUpDn = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcDiagDI
		RD_CONST XPTR GP_DiagDI = PICT_PcDiagDI;
        #else
        RD_CONST XPTR GP_DiagDI = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcDiagDO
		RD_CONST XPTR GP_DiagDO = PICT_PcDiagDO;
        #else
        RD_CONST XPTR GP_DiagDO = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcDiagAI
		RD_CONST XPTR GP_DiagAI = PICT_PcDiagAI;
        #else
        RD_CONST XPTR GP_DiagAI = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcMessAI
		RD_CONST XPTR GP_MessAI = PICT_PcMessAI;
        #else
        RD_CONST XPTR GP_MessAI = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcDiagAO
		RD_CONST XPTR GP_DiagAO = PICT_PcDiagAO;
        #else
        RD_CONST XPTR GP_DiagAO = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcMessAO
		RD_CONST XPTR GP_MessAO = PICT_PcMessAO;
        #else
        RD_CONST XPTR GP_MessAO = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcDiagCnt
		RD_CONST XPTR GP_DiagCnt = PICT_PcDiagCnt;
        #else
        RD_CONST XPTR GP_DiagCnt = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcKaliCnt
		RD_CONST XPTR GP_KaliCnt = PICT_PcKaliCnt;
        #else
        RD_CONST XPTR GP_KaliCnt = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcMessCnt
		RD_CONST XPTR GP_MessCnt = PICT_PcMessCnt;
        #else
        RD_CONST XPTR GP_MessCnt = RD_NOBINDATA;
		#endif
		
		#ifdef PICT_PcBKali
		RD_CONST XPTR GP_BKali = PICT_PcBKali;
        #else
        RD_CONST XPTR GP_BKali = RD_NOBINDATA;
		#endif
	
		#ifdef PICT_PcSetFactory
		RD_CONST XPTR GP_SetFactory = PICT_PcSetFactory;
        #else
        RD_CONST XPTR GP_SetFactory = RD_NOBINDATA;
		#endif
	
		#ifdef PICT_PcSetRange
		RD_CONST XPTR GP_SetRange = PICT_PcSetRange;
        #else
        RD_CONST XPTR GP_SetRange = RD_NOBINDATA;
		#endif

		#ifdef PICT_PcRoll
		RD_CONST XPTR GP_Roll = PICT_PcRoll;
        #else
        RD_CONST XPTR GP_Roll = RD_NOBINDATA;
		#endif
	
	#endif
	
	
	//*** werden evtl. noch uminitialisert
	CElement RD_MRAM * pGPassUser = NULL;
	CElement RD_MRAM * pGPassAdmin = NULL;
	CElement RD_MRAM * pGPassTech = NULL;
	CElement RD_MRAM * pGPassSuper = NULL;
	CElement RD_MRAM * pGPassImacs = NULL;
	#if RD_NO_BEEP == 0
		CElement RD_MRAM * pGSound = NULL;
	#endif
	CElement RD_MRAM * pGVersSys = NULL;
	CElement RD_MRAM * pGVersKali = NULL;
	CElement RD_MRAM * pGVersSoft = NULL;
	CElement RD_MRAM * pGVersPar = NULL;
	CElement RD_MRAM * pGVersProc = NULL;
	
#endif

#if ((NO_EMB_HMI == 0) || (RD_CE_ACCESS != 0))
	CElement RD_MROM * pGLanguage = NULL;
	short GActLanguageBank = 0;		// lfd. Nummer der wirklich vorhandenen Sprachbank
	short GActLanguage = -1;			// lfd. Sprachnummer (0=GR, 1=UK, 2=FR, ...) // -1 um Wechsel beim Start zu erkennen und noetige Initialisierungen bei Sprachwechsel durchzufuehren
#endif

#if NO_EMB_HMI == 0
RD_CONST VARPOOL_IDX GVarPoolUniqueOffset = RD_UNIQUEPOOL;
#if RD_PROPFONT != 0
RD_CONST short GPropPoolSize = RD_PROPPOOL_LENGTH;
#endif // RD_PROPFONT != 0
#endif // NO_EMB_HMI == 0

// Offsets in ext. Flash.
#ifdef OSDLINI_OFFSET
	unsigned long GFlashOffset_ini = OSDLINI_OFFSET;
#else
	unsigned long GFlashOffset_ini = 0L;
#endif
#ifdef OSDLBMP_OFFSET
	unsigned long GFlashOffset_bmp = OSDLBMP_OFFSET;
#else
	unsigned long GFlashOffset_bmp = 0L;
#endif
#ifdef OSDLTXT_OFFSET
	unsigned long GFlashOffset_txt = OSDLTXT_OFFSET;
#else
	unsigned long GFlashOffset_txt = 0L;
#endif


#ifndef ___CTR___
	// fuer Simulation: hier werden die Binaerdaten von Datei geladen
	BinaryInit InitBin(55);
#endif

#if MODUL_CHIPCARD != 0
	short cFuncSys2Card(M_D_SCR_S)
	{
		return(CModulMChipCard_cFuncSys2Card(M_SCR));
	}
	
	short cFuncCard2Sys(M_D_SCR_S)
	{
		return(CModulMChipCard_cFuncCard2Sys(M_SCR));
	}
	
	short cFuncPar2Card(M_D_SCR_S)
	{
		return(CModulMChipCard_cFuncPar2Card(M_SCR));
	}
	
	short cFuncCard2Par(M_D_SCR_S)
	{
		return(CModulMChipCard_cFuncCard2Par(M_SCR));
	}
	
	short cFuncKali2Card(M_D_SCR_S)
	{
		return(CModulMChipCard_cFuncKali2Card(M_SCR));
	}
	
	short cFuncCard2Kali(M_D_SCR_S)
	{
		return(CModulMChipCard_cFuncCard2Kali(M_SCR));
	}
	
	short cFuncFormatCard(M_D_SCR_S)
	{
		return(CModulMChipCard_cFuncFormatCard(M_SCR));
	}
	
	short cFuncGetCardDir(M_D_SCR_S)
	{
		return(CModulMChipCard_cFuncGetCardDir(M_SCR));
	}
#endif



// these files contain the generated data tables for Data Preservation and csv-Output.
#if (RD_VALUE_PRESERVE)
	#include "../APPL/preserveTab.c"
	unsigned short GetSizeOfElemIdxPrsvPntTab(void)
		{return (sizeof (ElemIdxPrsvPntTab) / sizeof(ElemIdxPrsvPntTab[0])) ;}
#endif
#if (defined(PARPRESRV_OFF) || defined(PARPRESRV_OFF_F))
	#include "../APPL/preservePar.c"
#endif
#if (defined(SYSPRESRV_OFF) || defined(SYSPRESRV_OFF_F))
	#include "../APPL/preserveSys.c"
#endif
#if (defined(PROCPRESRV_OFF) || defined(PROCPRESRV_OFF_F))
	#include "../APPL/preserveProc.c"
#endif

#endif // __CTR_INIT_H__