#ifndef ___CTR_UTIL_H___
#define ___CTR_UTIL_H___

// die Fehlererkennung zur Laufzeit wird mit "#if RD_ERROR_CHECK != 0" aktiviert
void 	RdSystemError(short errorNr);
void 	RdSystemErrorA(short errorNr, long info);

// If changing something in this list of defines for error messages
// change the list in errorHandling.cpp for Simulation, too.
#define SYSERR_HMI_TERMINATED		0x32 // vermutlich ist SurfaceStack untergelaufen
#define SYSERR_NO_STARTMOD		0x33
#define SYSERR_NO_SURFACE		0x34
#define SYSERR_EMPTY_SURFACE	0x35

#define SYSERR_WRONG_CFUNCNO		0x1001
#define SYSERR_UNKNOWN_REF		0x1002
#define SYSERR_UNKNOWN_ACTION		0x1004
#define SYSERR_SCREENORG_OVER		0x1007
#define SYSERR_FULL_OVER			0x1008
#define SYSERR_UNDEF_ENABLE_BIT	0x100b
#define	SYSERR_STACK_SIZE		0x1011


#define NULLPTR_VIS_03			0x2776	// in DVisFull_execute()
#define NULLPTR_VIS_04			0x2777	// in DVisFull_execute()
#define NULLPTR_VIS_05			0x2778	// in DVisFull_execute()
#define NULLPTR_VIS_06			0x2779	// in DVisCond_evalCond()
#define NULLPTR_VIS_07			0x277A	// in DVisActionCondition_evalCond()
#define NULLPTR_VIS_08			0x277B	// in condition()
#define NULLPTR_VIS_09			0x277C	// in condition()
#define NULLPTR_VIS_10			0x277D	// in condition()
#define NULLPTR_VIS_12			0x277F	// in getModulePointer()
#define NULLPTR_VIS_13			0x2780	// in DVisFull_draw()
#define NULLPTR_VIS_14			0x2781	// in DVisFull_draw()
#define NULLPTR_VIS_15			0x2782	// in DVisFull_draw()
#define NULLPTR_VIS_16			0x2783	// in DVisFull_update()
#define NULLPTR_VIS_17			0x2784	// in DVisFull_update()
#define NULLPTR_VIS_18			0x2785	// in DVisFull_update()
#define NULLPTR_VIS_19			0x2786	// in initMenu() and initMenuNewSur()
#define NULLPTR_VIS_20			0x2787	// in initMenu() and initMenuNewSur()
#define NULLPTR_VIS_21			0x2788	// in initMenu() and initMenuNewSur()
#define NULLPTR_VIS_23			0x278A	// in menuExecuteKey()
#define NULLPTR_VIS_24			0x278B	// in menuExecuteKey()
#define NULLPTR_VIS_25			0x278C	// in menuExecuteKey()
#define NULLPTR_VIS_26			0x278D	// in DVisFull_init()
#define NULLPTR_VIS_27			0x278E	// in DVisFull_init()
#define NULLPTR_VIS_28			0x278F	// in DVisFull_init()
#define NULLPTR_VIS_30			0x2791	// in doSurInterpreter()
#define NULLPTR_VIS_32			0x2793	// in visElem_updateOld()
#define NULLPTR_VIS_33			0x2794	// in DVisSElemBar_update()
#define NULLPTR_VIS_35			0x2796	// in condition()
#define NULLPTR_VIS_38			0x2799	// in draw_object()

#define UNKNOWNTYPE_MELM		0x279B  // in DVisMElem_draw()
#define UNKNOWNTYPE_VIS_1		0x279C	// in draw_object()
#define INTERPR_OVER			0x279D	// Interpreteranzahl ist uebergelaufen

#define NULLPTR_CE_01			0x27D9	// in CModul_getVisIdx()
#define NULLPTR_CE_02			0x27DA	// in CModul_getElem()
#define NULLPTR_CE_14			0x27E6	// in CElement_getActTxtWithST()
#define NULLPTR_CE_15			0x27E7	// in CModul_getName()
#define NULLPTR_CE_16			0x27E8	// in CModul_getName()

#define NULLPTR_DIAG_01			0x283D	// in kaliset_ai()
#define NULLPTR_DIAG_02			0x283E	// in kaliset_ai()
#define NULLPTR_DIAG_03			0x283F	// in kaliset_ai()
#define NULLPTR_DIAG_04			0x2840	// in kaliset_ai()
#define NULLPTR_DIAG_05			0x2841	// in kaliset_ao()
#define NULLPTR_DIAG_06			0x2842	// in kaliset_ao()
#define NULLPTR_DIAG_07			0x2843	// in kaliset_ao()
#define NULLPTR_DIAG_08			0x2844	// in kaliset_ao()
#define NULLPTR_DIAG_09			0x2845	// in ai_set_access()
#define NULLPTR_DIAG_10			0x2846	// in ai_res_access()
#define NULLPTR_DIAG_11			0x2847	// in ai_test_access()
#define NULLPTR_DIAG_12			0x2848	// in ao_set_access()
#define NULLPTR_DIAG_13			0x2849	// in ao_res_access()
#define NULLPTR_DIAG_14			0x284A	// in ao_test_access()
#define NULLPTR_DIAG_15			0x284B	// in cnt_set_access()
#define NULLPTR_DIAG_16			0x284C	// in cnt_res_access()
#define NULLPTR_DIAG_17			0x284D	// in cnt_test_access()
#define NULLPTR_DIAG_18			0x284E	// in kaliset_cnt()
#define NULLPTR_DIAG_19			0x284F	// in kaliset_cnt()
#define NULLPTR_DIAG_20			0x2850	// in kaliset_cnt()
#define NULLPTR_DIAG_21			0x2851	// in kaliset_cnt()

#define NULLPTR_UTIL			0x28A1	// in doActionTypeChngElemVal()

#define NULLPTR_MODTAB			0x29CD
#define NULLPTR_ELEMTAB			0x29CE

#define	OBJ_NOEXTRECT			0x29D0 // for object version without extended rectangle support

// Attention: Because of adding the type of error to the checksum, the errors
// have to be in the order Checksum, size, ID, Version and on consecutive numbers
#define INITERR_PERSCOM			0x3000 // Persistent data communication error
#define INITERR_PARCHECKSUM		0x3001 // Parameter checkusm error
#define INITERR_PARSIZE			0x3002 // Parameter size error
#define INITERR_PARID			0x3003 // Parameter ID error
#define INITERR_PARVERSION		0x3004 // Parameter Version error
#define INITERR_SYSCHECKSUM		0x3005 // System-Parameter checkusm error
#define INITERR_SYSSIZE			0x3006 // System-Parameter size error
#define INITERR_SYSID			0x3007 // System-Parameter ID error
#define INITERR_SYSVERSION		0x3008 // System-Parameter Version error
#define INITERR_CALICHECKSUM	0x3009 // Calibration data checkusm error
#define INITERR_CALIESIZE		0x300A // Calibration data size error
#define INITERR_CALIID			0x300B // Calibration data ID error
#define INITERR_CALIVERSION		0x300C // Calibration data Version error
#define INITERR_PROCCHECKSUM	0x300D // Process data checkusm error
#define INITERR_PROCSIZE		0x300E // Process data size error
#define INITERR_PROCID			0x300F // Process data ID error
#define INITERR_PROCVERSION		0x3010 // Process data Version error
#define INITERR_REMACHECKSUM	0x3011 // Remanent data checkusm error
#define INITERR_REMASIZE		0x3012 // Remanent data size error
#define INITERR_REMAID			0x3013 // Remanent data ID error
#define INITERR_REMAVERSION		0x3014 // Remanent data Version error


typedef	void	TASKFUNC(void);

extern	long *masktab;


//*** Funktionen und Daten fr die Taskview
typedef struct 
{
short act;
short min;
short max;
long countervariable;
long lastTime;
char taskName[20];
}task_behaviour;
	  	
extern task_behaviour taskdaten[];

long getActTime(void);
void protTaskBehaviour(task_behaviour *tbh, char *tasktype);

//*** Funktionen fr die echtzeituhr
void	rtc_read(TIME *);
void	rtc_write(TIME *);

// Funktionen fr Kalibrierung
void	init_kali(void);
// Problem "Pointer auf KALI": da KALI je nach Prijekt-Definition im RAM oder im ROM (feste Kalibrierung) liegen kann
// Lsung: wir nehmen RD_ROM, da dieser aus technischen Grnden vom Umfang (near, far) immer > RD_RAM ist.
unsigned short aoDefaultLog2Phys(E_KALIIO RD_MIO *io, void *logval, void* physval);
unsigned short aiDefaultPhys2Log(E_KALIIO RD_MIO *io, void* physval, void* logval);
unsigned short cntDefaultPhys2Log(E_KALIIO RD_MIO *io, void* physval, void* logval);

void	quickkali(short index, short information);
void	PersistHandling(void);

short	ram_init(unsigned char **, unsigned short);
void	ram_write(void *, void *, unsigned short);

//short	tim_init(void);

void	var_write(unsigned short, void *, unsigned short);
void	var_read(unsigned short, void *, unsigned short);
void	fmem_write(void * block,unsigned short seg,unsigned short off, unsigned short size);
void	fmem_read(unsigned short seg,unsigned short off,void * block,unsigned short size);
void	prot_write(void * block, long adr, unsigned short size);
void	prot_read(long adr, void * block,unsigned short size);

void	int_enable(void);
void	task_exit(void);
void	c_key_stat_test(void);

long	get_sp_pos(void);

void	do_error(short);


extern	short PC_PWDLEVEL;
extern  short DokuLang;

#ifndef ___CTR___
void    sysmem_read(void RD_MRAM *, unsigned short, unsigned short);
void    sysmem_write(unsigned short, void RD_MRAM *, unsigned short);
short	countActions(XPTR actions);
#endif

/**********************************************************************
 hardware functions
**********************************************************************/	
short protInitHeader(void);
short protTestHeader(void);

#if USE_RDI_INDEX != 0
	void InitDistTarget(short sourceNode, short drainNode, RD_CONST RD_MCOM RD_IDX_PNT_TAB *recTab, short numEntries, unsigned char comtypeMask, short delay);
	void InitAllDistTargets(short drainNode, unsigned char comtypeMask);
#endif


#endif //___CTR_UTIL_H___
