//
// $Id: diag.h 8941 2016-04-05 13:23:14Z wdaur $
//
// Copyright (c) IMACS GmbH Germany. All rights reserved.
//

//*** Act_Height ist die y-position des actwertes des angewaehlten Elementes
//*** LOW_HEIGHT und UP_HEIGHT sind die y-positionen der Zeilen des oberen/unteren Kalibrierpunktes des angewaehlten Elementes
//*** NumMenuMax wird bei diag_ai(), diag_ao() und diag_cnt() verwendet und gibt die anzahl der zeilen an,
//*** die fuer das elementmenue im display zur verfuegung stehen
//*** FOOTMENU legt fest, ob eine Fusszeile definiert ist
//*** FootMenuPosY legt fest, wo die Fusszeile y-maessig anfaengt

#define 	MENU_OFFY		20

#if (defined(MAXLINES64) || defined(MAXLINES96))	// X x 768 Pixel
	#define	DK_FONT_SIZE	12
	#define	ACT_HEIGHT		-40		// y-display pos.: actual cali point
	#define	LOW_HEIGHT		-60		// y-display pos.: lower cali point
	#define	UP_HEIGHT		-72		// y-display pos.: upper cali point
	#define	FOOTMENU 		1
	#define	FootMenuPosY	-120
	#define	DESCPOSY		-4
	#define	NUM_D_MENU_MAX	6		// number of lines in digital diag 
	#define	POS_D_MENU		-40		// y-display pos.: actual value and start of listing
	#define	NUM_A_MENU_MAX	6		// number of lines in analog diag/cali 
	#define	POS_A_MENU		-40		// y-display pos.: actual value and start of listing
	#define	KALI_MENU_LINE	3		// number of lines in the direct menue of one element
#endif
#if (defined(MAXLINES50) || defined(MAXLINES75))	// X x 600 Pixel
	#define	DK_FONT_SIZE	12
	#define	ACT_HEIGHT		-40		// y-display pos.: actual cali point
	#define	LOW_HEIGHT		-60		// y-display pos.: lower cali point
	#define	UP_HEIGHT		-72		// y-display pos.: upper cali point
	#define	FOOTMENU 		1
	#define	FootMenuPosY	-120
	#define	DESCPOSY		-4
	#define	NUM_D_MENU_MAX	6		// number of lines in digital diag 
	#define	POS_D_MENU		-40		// y-display pos.: actual value and start of listing
	#define	NUM_A_MENU_MAX	6		// number of lines in analog diag/cali 
	#define	POS_A_MENU		-40		// y-display pos.: actual value and start of listing
	#define	KALI_MENU_LINE	3		// number of lines in the direct menue of one element
#endif
#if (defined(MAXLINES40) || defined(MAXLINES60))	// X x 480 Pixel
	#define	DK_FONT_SIZE	12
	#define	ACT_HEIGHT		-40
	#define	LOW_HEIGHT		-60
	#define	UP_HEIGHT		-72
	#define	FOOTMENU 		1
	#define	FootMenuPosY	-120
	#define	DESCPOSY		-4
	#define	NUM_D_MENU_MAX	6
	#define	POS_D_MENU		-40
	#define	NUM_A_MENU_MAX	6
	#define	POS_A_MENU		-40
	#define	KALI_MENU_LINE	3
#endif
#if (defined(MAXLINES20) || defined(MAXLINES30))	// 320 x 240 Pixel
	#define	DK_FONT_SIZE	12
	#define	ACT_HEIGHT		-40
	#define	LOW_HEIGHT		-60
	#define	UP_HEIGHT		-72
	#define	FOOTMENU 		1
	#define	FootMenuPosY	-120
	#define	DESCPOSY		-4
	#define	NUM_D_MENU_MAX	6
	#define	POS_D_MENU		-40
	#define	NUM_A_MENU_MAX	6
	#define	POS_A_MENU		-40
	#define	KALI_MENU_LINE	3
#endif
#ifdef MAXLINES16		// 128/160 x 128 Pixel
	#define	DK_FONT_SIZE	12
	#define	ACT_HEIGHT		-28
	#define	LOW_HEIGHT		-40
	#define	UP_HEIGHT		-52
	#define	FOOTMENU 		1
	#define	FootMenuPosY 	-120
	#define	DESCPOSY		-4
	#define	NUM_D_MENU_MAX	6
	#define	POS_D_MENU		-24
	#define	NUM_A_MENU_MAX	6
	#define	POS_A_MENU		-24
	#define	KALI_MENU_LINE	3
#endif
#ifdef MAXLINES8		// 128/240 x 64 Pixel
	#define	DK_FONT_SIZE	8	
	#define	ACT_HEIGHT		-22
	#define	LOW_HEIGHT		-34
	#define	UP_HEIGHT		-42
	#define	FOOTMENU 		1
	#define	FootMenuPosY	-52
	#define	DESCPOSY		-4
	#define	NUM_D_MENU_MAX	3
	#define	POS_D_MENU		-24
	#define	NUM_A_MENU_MAX	4
	#define	POS_A_MENU		-18
	#define	KALI_MENU_LINE	3
#endif
#ifdef MAXLINES4		//   120/122/128 x 32 Pixel
	#define	DK_FONT_SIZE	8	
	#define	ACT_HEIGHT		-8
	#define	LOW_HEIGHT		-16
	#define	UP_HEIGHT		-24
	#define	FOOTMENU 		1
	#define	FootMenuPosY 	-24
	#define	DESCPOSY		0
	#define	NUM_D_MENU_MAX	3
	#define	POS_D_MENU		-8
	#define	NUM_A_MENU_MAX	3
	#define	POS_A_MENU		-8
	#define	KALI_MENU_LINE	3
#endif
#ifdef MAXLINES2
	#define	DK_FONT_SIZE	8	
	#define	ACT_HEIGHT		-8
	#define	LOW_HEIGHT		-34
	#define	UP_HEIGHT		-42
	#define	DESCPOSY		0
	#define	NUM_D_MENU_MAX	1
	#define	POS_D_MENU		-8
	#define	NUM_A_MENU_MAX	1
	#define	POS_A_MENU		-8
	#define	KALI_MENU_LINE	1
#endif
#ifdef MAXLINES1
	#define	DK_FONT_SIZE	8	
	#define	ACT_HEIGHT		-8
	#define LOW_HEIGHT		-34
	#define	UP_HEIGHT		-42
	#define	DESCPOSY		0
	#define	NUM_D_MENU_MAX	1
	#define	POS_D_MENU		0
	#define	NUM_A_MENU_MAX	1
	#define	POS_A_MENU		0
	#define	KALI_MENU_LINE	0
#endif


//*** PHYSICAL_X und LOGICAL_X sind die x-positionen der physikalsichen/logischen Werte des angewaehlten Elementes
#ifdef MAXCOLUMNS6		// z.B. 6 x 1 Char
	#define	PHYSICAL_X		62
	#define	LOGICAL_X		42
	#define	DESCPOSX		0
	#define	DESCR_MARGIN_X	5		// character
	#define	IOS_PER_LINE	12		// digital IO-Elements per line
#endif
#ifdef MAXCOLUMNS16		// z.B. 16 x 2 Char
	#define	PHYSICAL_X		66
	#define	LOGICAL_X		58
	#define	DESCPOSX		0
	#define	DESCR_MARGIN_X	5
	#define	IOS_PER_LINE	12
#endif
#ifdef MAXCOLUMNS20		// z.B. 122 x 32 Pixel
	#define	PHYSICAL_X		84
	#define	LOGICAL_X		66
	#define	DESCPOSX		0
	#define	DESCR_MARGIN_X	5
	#define	IOS_PER_LINE	16
#endif
#ifdef MAXCOLUMNS21		// z.B. 128 x 64/128 Pixel
	#define	PHYSICAL_X		80
	#define	LOGICAL_X		48
	#define	DESCPOSX		30
	#define	DESCR_MARGIN_X	0
	#define	IOS_PER_LINE	16
#endif
#ifdef MAXCOLUMNS26		// z.B. 160 x 128 Pixel
	#define	PHYSICAL_X		98
	#define	LOGICAL_X		72
	#define	DESCPOSX		30
	#define	DESCR_MARGIN_X	0
	#define	IOS_PER_LINE	20
#endif
#ifdef MAXCOLUMNS32		// z.B. 192 x 64 Pixel
	#define	PHYSICAL_X		98
	#define	LOGICAL_X		72
	#define	DESCPOSX		30
	#define	DESCR_MARGIN_X	0
	#define	IOS_PER_LINE	20
#endif
#ifdef MAXCOLUMNS40		// z.B. 240 x 64/128 Pixel
	#if MAX_LINES > 8		// 320 x 240
		#define	PHYSICAL_X		150
		#define	LOGICAL_X		100
		#define	DESCPOSX		80	
		#define	DESCR_MARGIN_X	0
		#define	IOS_PER_LINE	24
	#else					// 240 x 64
		#define	PHYSICAL_X		98
		#define	LOGICAL_X		72
		#define	DESCPOSX		30	
		#define	DESCR_MARGIN_X	0
		#define	IOS_PER_LINE	24
	#endif	
#endif
#ifdef MAXCOLUMNS42		// z.B. 256 x 128 Pixel
	#define	PHYSICAL_X		150
	#define	LOGICAL_X		100
	#define	DESCPOSX		80	
	#define	DESCR_MARGIN_X	0
	#define	IOS_PER_LINE	24
#endif
// alles >= 1/4 VGA
#if (defined(MAXCOLUMNS53) || defined(MAXCOLUMNS80) || defined(MAXCOLUMNS100) || defined(MAXCOLUMNS106)  || defined(MAXCOLUMNS128)  || defined(MAXCOLUMNS133)  || defined(MAXCOLUMNS170))
	#define	PHYSICAL_X		120
	#define	LOGICAL_X		90
	#define	DESCPOSX		80
	#define	DESCR_MARGIN_X	0
	#define	IOS_PER_LINE	32
#endif

//*** Aktionen in den cfunctionen
#define	CF_HOCH		1
#define	CF_RUNTER	2
#define	CF_RECHTS	3
#define	CF_LINKS	4
#define	CF_ESC		5
#define	CF_TOGGLE	6
#define	CF_SET		7
#define	CF_RES		8
#define	CF_HELP		9
#define	CF_KALI_U	10
#define	CF_KALI_O	11
#define	CF_KALI_STD	12
