@echo off
SETLOCAL EnableExtensions EnableDelayedExpansion

set "DIAGVERS=4"

echo ---------- radCASE-Diagnosis ---------- > radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log

echo Diagnosis-Version !DIAGVERS! >> radCASE-Diagnosis.log

echo. >> radCASE-Diagnosis.log
echo. ---------- System ---------- >> radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log

echo | set /p=Try reading registry >> radCASE-Diagnosis.log
reg query HKLM >NUL 2>NUL
if errorlevel 1 (
	echo -- Failed >> radCASE-Diagnosis.log
	echo Error message: >> radCASE-Diagnosis.log
	reg query HKLM >NUL 2>>radCASE-Diagnosis.log
) else (
	echo -- Successfull >> radCASE-Diagnosis.log
)
echo. >> radCASE-Diagnosis.log

echo Content of path variable: >> radCASE-Diagnosis.log
echo %PATH% >> radCASE-Diagnosis.log

echo. >> radCASE-Diagnosis.log
echo ---------- .NET ---------- >> radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log

for /F "usebackq tokens=2*" %%a in (`reg query "HKEY_LOCAL_MACHINE\Software\Microsoft\NET Framework Setup\NDP\v3.5" /v SP`) do (
	set /A SpVers=%%b
)
if !SpVers! LSS 1 (
	echo required version of .NET 3.5 SP1 NOT found - ERROR >> radCASE-Diagnosis.log
) else (
	echo required version of .NET 3.5 SP1 found - OK >> radCASE-Diagnosis.log
)

echo. >> radCASE-Diagnosis.log
echo ---------- radCASE ---------- >> radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log

echo Content of buildNo.txt >> radCASE-Diagnosis.log
type "%OSDL_SYS%\def\buildNo.txt" >> radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log

echo. >> radCASE-Diagnosis.log
echo Content of CompatibilityCheck.txt >> radCASE-Diagnosis.log
type "%OSDL_SYS%\def\CompatibilityCheck.txt" >> radCASE-Diagnosis.log

echo. >> radCASE-Diagnosis.log
echo ---------- Visual Studio ---------- >> radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log

set SupVersion=
if exist "%OSDL_SYS%\soft\Sim2005" set "SupVersion=!SupVersion! 8.0"
if exist "%OSDL_SYS%\soft\Sim2008" set "SupVersion=!SupVersion! 9.0"
if exist "%OSDL_SYS%\soft\Sim2010" set "SupVersion=!SupVersion! 10.0"
if exist "%OSDL_SYS%\soft\Sim2012" set "SupVersion=!SupVersion! 11.0"
if exist "%OSDL_SYS%\soft\Sim2013" set "SupVersion=!SupVersion! 12.0"
if exist "%OSDL_SYS%\soft\Sim2015" set "SupVersion=!SupVersion! 14.0"

echo Visual Studio versions supported by radCASE: >> radCASE-Diagnosis.log
echo !SupVersion! >> radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log

for %%a in (!SupVersion!) do (
	for %%b in (VCExpress\ VisualStudio\) do (
		for %%c in (SOFTWARE\Microsoft\ SOFTWARE\Wow6432Node\Microsoft\) do (
			set KEY_NAME="HKEY_LOCAL_MACHINE\%%c%%b%%a\Setup\VC"
			echo Searching registry path !KEY_NAME! >> radCASE-Diagnosis.log
			for /F "usebackq tokens=2*" %%d in (`REG QUERY !KEY_NAME! /v ProductDir 2^>nul`) do (
				call :VSInspect %%a "!KEY_NAME!" "%%e"
				set "VERSION=%%a"
			)
		)
	)
)

echo Using VS-Version: !VSVER! >> radCASE-Diagnosis.log

set MSVC_BIN=
call "%OSDL_SYS%\ctr_lib\arg_batches\set_msvc_bin.bat" !VERSION!
echo MSVC_BIN: !MSVC_BIN! >> radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log

call "!MSVC_BIN!\vcvars32.bat" >> radCASE-Diagnosis.log 2>&1
echo PATH after vcvars: >> radCASE-Diagnosis.log
echo %PATH% >> radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log

echo MsBuild version: >> radCASE-Diagnosis.log
call msbuild /version >> radCASE-Diagnosis.log 2>&1
exit /b 0

:VSInspect
if "%~1"=="8.0" set VSVER=2005
if "%~1"=="9.0" set VSVER=2008
if "%~1"=="10.0" set VSVER=2010
if "%~1"=="11.0" set VSVER=2012
if "%~1"=="12.0" set VSVER=2013
if "%~1"=="14.0" set VSVER=2015
echo. >> radCASE-Diagnosis.log
echo --------------------------------------------------------------------------- >> radCASE-Diagnosis.log
echo Found Visual Studio !VSVER! >> radCASE-Diagnosis.log
echo Registry path: %~2 >> radCASE-Diagnosis.log
echo Installation path: %~3 >> radCASE-Diagnosis.log

set "CURDIR=%CD%"
pushd.
set "VSNUMVERS=%~1"
cd /D "%~3\redist\x86\Microsoft.VC!VSNUMVERS:.=!.CRT" >NUL 2>NUL
if errorlevel 1 (
	echo Redist directory not found >> !CURDIR!\radCASE-Diagnosis.log
) else (
	echo Redist directory found >> !CURDIR!\radCASE-Diagnosis.log
	echo Redist directory contains following files: >> !CURDIR!\radCASE-Diagnosis.log
	call dir >> !CURDIR!\radCASE-Diagnosis.log
)
popd
if "!VSVER!"=="2015" (
	call :GETSDK10INSTALLPATH SdkInstallPath
	echo. >> radCASE-Diagnosis.log
	echo SDK-Installpath: !SdkInstallPath! >> radCASE-Diagnosis.log

	pushd.
	cd /D "!SdkInstallPath!\Redist\ucrt\DLLs\x86" >NUL 2>NUL
	if errorlevel 1 (
		echo SDK Redist directory not found >> !CURDIR!\radCASE-Diagnosis.log
	) else (
		echo SDK Redist directory found >> !CURDIR!\radCASE-Diagnosis.log
		echo Redist directory contains following files: >> !CURDIR!\radCASE-Diagnosis.log
		call dir >> !CURDIR!\radCASE-Diagnosis.log
	)
	popd
)

if !VSVER! GEQ 2012 (
	call :CHECKXPSupport XPSupportPath
    echo. >> radCASE-Diagnosis.log
	echo Checking for XP Support >> radCASE-Diagnosis.log
	pushd.
	cd /D "!XPSupportPath!" >NUL 2>NUL
	if errorlevel 1 (
		echo XP Support NOT installed - ERROR >> !CURDIR!\radCASE-Diagnosis.log
	) else (
		echo XP Support installed - OK >> !CURDIR!\radCASE-Diagnosis.log
	)
	popd
)
echo --------------------------------------------------------------------------- >> radCASE-Diagnosis.log
echo. >> radCASE-Diagnosis.log

goto :EOF

:GETSDK10INSTALLPATH
for %%a in (SOFTWARE\Microsoft\ SOFTWARE\Wow6432Node\Microsoft\) do (
	set KEY_NAME="HKEY_LOCAL_MACHINE\%%aMicrosoft SDKs\Windows\v10.0"
	for /F "usebackq tokens=2*" %%b in (`REG QUERY !KEY_NAME! /v InstallationFolder 2^>nul`) do (
		set "%~1=%%c"
	)
)
goto :EOF

:CHECKXPSupport
for %%a in (SOFTWARE\Microsoft\ SOFTWARE\Wow6432Node\Microsoft\) do (
	set KEY_NAME="HKEY_LOCAL_MACHINE\%%aMicrosoft SDKs\Windows\v7.1A\XPSupport"
	for /F "usebackq tokens=2*" %%b in (`REG QUERY !KEY_NAME! /v InstallationFolder 2^>nul`) do (
		set "%~1=%%c"
	)
)
goto :EOF